
  -- 4.1.1 Materil (Material)
   DROP TABLE material;
   CREATE TABLE material (
	ARTICEL            VARCHAR(10) PRIMARY KEY,
	TYP                VARCHAR(80),
	QTY1min            NUMERIC(12,2),
	UNIT               VARCHAR(3)  CHECK ((UNIT = 'm') OR (UNIT = 'mm')  OR
		(UNIT = 'kg') OR (UNIT = 'g') OR (UNIT = 't') OR (UNIT = 'ks')
		OR (UNIT = 'ks'))
	);

  -- 4.1.3 Tabulka odpvdnch pracovnk (PlnCd)
   DROP TABLE PlnCd;
   DROP SEQUENCE plncd_id_seq;
   CREATE TABLE PlnCd (
         ID            SERIAL NOT NULL PRIMARY KEY,
	 JMENO         VARCHAR(15),
	 PRIJMENI      VARCHAR(15),
	 TELEFON       VARCHAR(12) NOT NULL,
	 FAX           VARCHAR(12),
	 EMAIL         VARCHAR(40)
       );
  

  -- 4.1.2 Sklad (Sklad)
   DROP TABLE sklad;
   CREATE TABLE sklad (
        LOCATION      VARCHAR(10) PRIMARY KEY,
	TYP           CHAR(1) NOT NULL CHECK ((TYP >= 'a' AND TYP <='z') OR 
		(TYP >= 'A' AND TYP <='Z')),
	NAZEV         VARCHAR(20) NOT NULL,
	ULICE         VARCHAR(20),
	MESTO         VARCHAR(20),
	PSC           CHAR(5),
	PlnCd         INTEGER  REFERENCES PlnCd(ID) NOT NULL,
	POZNAMKA TEXT
	);
	
  -- 4.1.4 Telefony (Telefony)
    DROP TABLE telefony;
    CREATE TABLE telefony (
         SKLAD        VARCHAR(10) NOT NULL REFERENCES sklad(LOCATION),
         TELEFON      VARCHAR(12),
         FAX          VARCHAR(12),
         EMAIL        VARCHAR(40),
         POZNAMKA     VARCHAR(80)
       );
		   
  -- 4.1.6 Mna
     DROP TABLE mena;
     CREATE TABLE mena (
	M             CHAR(3) PRIMARY KEY,
	RAD           INTEGER  NOT NULL CHECK (RAD > 0),
	KURS          NUMERIC(6,3) NOT NULL CHECK (KURS > 0)
	);
	 
  -- 4.1.5 Cenk (Cenik)
     DROP TABLE cenik;
     CREATE TABLE cenik (
	ARTICEL       VARCHAR(10) NOT NULL REFERENCES material(ARTICEL),
    	SKLAD         VARCHAR(10) NOT NULL REFERENCES sklad(LOCATION),
	QTY1          NUMERIC(12,2) NOT NULL CHECK (QTY1 >= 0),
	PRICE         NUMERIC(10,2) NOT NULL CHECK (PRICE > 0),
	M             CHAR(3) NOT NULL REFERENCES mena(M)
       );

     CREATE UNIQUE INDEX cenik_key ON cenik(ARTICEL,SKLAD);
     
  -- 4.1.7 Objednvka (Objednavka)
     DROP TABLE objednavka;
     CREATE TABLE objednavka (
      CISLO         VARCHAR(10) PRIMARY KEY,
      PRO           VARCHAR(10) NOT NULL REFERENCES sklad(LOCATION),
      OD            VARCHAR(10) NOT NULL REFERENCES sklad(LOCATION),
      OBJEDNANO     DATE NOT NULL DEFAULT current_date,
      VYRIZENO      DATE
      );

  -- 4.1.8 Poloky objednvky (Objednavka_polozky)
     DROP TABLE objednavka_polozky;
     CREATE TABLE objednavka_polozky (
      CISLO         VARCHAR(10) NOT NULL REFERENCES objednavka (CISLO),
      ARTICEL       VARCHAR(10) NOT NULL REFERENCES material(ARTICEL),
      QTY2          NUMERIC(12,2) CHECK (QTY2 >= 0)
      );

  --  4.2.1 Objednvky
   DROP VIEW view_objednavky;
   CREATE VIEW view_objednavky AS
   SELECT objednavka.cislo AS Objednavka,pro,od, articel,qty2,objednano,vyrizeno
   FROM objednavka, objednavka_polozky
   WHERE objednavka.cislo = objednavka_polozky.cislo
   ORDER BY objednavka.cislo;

   DROP VIEW view_objednavky_sum;
   CREATE VIEW view_objednavky_sum AS
   SELECT od, articel,sum(qty2) AS qty2
   FROM view_objednavky GROUP BY od,articel;
		   

  --  4.2.2 Mnostv materilu
    DROP VIEW view_vlastni_material;  
    CREATE VIEW view_vlastni_material AS
    SELECT articel, sklad, qty1,price
    FROM cenik,sklad
    WHERE location=sklad and typ='i';
		
    DROP VIEW view_vlastni_material_mnozstvi;	 	
    CREATE VIEW view_vlastni_material_mnozstvi AS
    SELECT sklad,view_vlastni_material.articel,qty1,qty2,qty1-qty2 AS qty
    FROM view_vlastni_material
    LEFT JOIN view_objednavky_sum
    ON od=sklad AND view_vlastni_material.articel = view_objednavky_sum.articel;
				   
   -- 4.2.3 Cena
   DROP VIEW view_cena;
   CREATE VIEW view_cena AS
   SELECT articel, sklad, qty1, round(price*kurs/rad,2), 'Kc' as Mena
   FROM cenik,mena WHERE cenik.m = mena.m ORDER BY articel;


INSERT INTO material VALUES ('R840816','FRM IPIX CTRL BOX',0,'ks');
INSERT INTO material VALUES ('R840817','FRM IPIX CTRL CVR',0,'ks');
INSERT INTO material VALUES ('R840819','FRM DLITE SNGLE RSYSNC TOP',0,'ks');
INSERT INTO material VALUES ('B30802T','AL EXTR 30x30 BOSH WH',50,'m');
INSERT INTO material VALUES ('P242118','BOX LAURA INTERFACE',100,'ks');
INSERT INTO material VALUES ('Z363738T','I SCR ST M4 X 6 STZN',200,'ks');

INSERT INTO PlnCd(JMENO,PRIJMENI,TELEFON,FAX,EMAIL) VALUES
('Jan','Nov','312312312','312312312','jan.novy@seznam.cz');
INSERT INTO PlnCd(JMENO,PRIJMENI,TELEFON) VALUES
('Martin','Nov','233333333');
INSERT INTO PlnCd(JMENO,PRIJMENI,TELEFON) VALUES
('Tom','Nov','111111111');
INSERT INTO PlnCd(JMENO,PRIJMENI,TELEFON) VALUES
('Martin','Star','222555555');
INSERT INTO PlnCd(JMENO,PRIJMENI,TELEFON) VALUES
('Tom','Star','444444444');
  

INSERT INTO sklad VALUES ('96','i','Stavebni firma s.r.o','Polska','Kladno','27202',1);
INSERT INTO sklad VALUES ('97','i','Sklad I','Polska','Kladno','27202',1);
INSERT INTO sklad VALUES ('98','i','Sklad II','Polska','Kladno','27202',1);
INSERT INTO sklad VALUES ('ASS','e','Sklad I s.r.o','Polska','Kladno','27202',2);
INSERT INTO sklad VALUES ('ASS2','e','Sklad II s.r.o','Polska','Kladno','27202',3);
INSERT INTO sklad VALUES ('VS1','v','Vrobce I s.r.o','Polska','Kladno','27202',4);
INSERT INTO sklad VALUES ('VS2','v','Vrobce II s.r.o','Polska','Kladno','27202',5);

INSERT INTO telefony(SKLAD,TELEFON,POZNAMKA) VALUES ('ASS','312111111','Sef vydeje materialu');
INSERT INTO telefony(SKLAD,FAX,POZNAMKA) VALUES ('ASS2','312222222','Vedouci smeny');
INSERT INTO telefony(SKLAD,EMAIL,POZNAMKA) VALUES ('ASS2','SkladII@centrum.cz','Kancelar vedouciho');
 
INSERT INTO mena VALUES ('Sk',100,'86');
INSERT INTO mena VALUES ('Kc',1,'1');
INSERT INTO mena VALUES ('EUR',1,'40');

INSERT INTO cenik VALUES ('R840816','97',50,500,'Kc');
INSERT INTO cenik VALUES ('R840817','97',75,524,'Kc');
INSERT INTO cenik VALUES ('R840819','97',26,399,'Kc');
INSERT INTO cenik VALUES ('R840819','98',24,399,'Kc');
INSERT INTO cenik VALUES ('B30802T','98',50,2000,'Kc');
INSERT INTO cenik VALUES ('P242118','98',530,55,'Kc');
INSERT INTO cenik VALUES ('Z363738T','98',20,53,'Kc');


INSERT INTO cenik VALUES ('R840816','ASS2',200,510,'Kc');
INSERT INTO cenik VALUES ('R840817','ASS2',750,530,'Kc');
INSERT INTO cenik VALUES ('R840819','ASS2',200,410,'Kc');
INSERT INTO cenik VALUES ('B30802T','ASS',50,2020,'Kc');
INSERT INTO cenik VALUES ('P242118','ASS',30,55.5,'Kc');
INSERT INTO cenik VALUES ('Z363738T','ASS',0,54.5,'Kc');


INSERT INTO cenik VALUES ('R840816','VS1',0,12,'EUR');
INSERT INTO cenik VALUES ('R840817','VS1',0,15,'EUR');
INSERT INTO cenik VALUES ('R840819','VS1',0,8.5,'EUR');
INSERT INTO cenik VALUES ('P242118','VS1',0,1.1,'EUR');
INSERT INTO cenik VALUES ('B30802T','VS2',0,49,'EUR');
INSERT INTO cenik VALUES ('P242118','VS2',0,1.2,'EUR');
INSERT INTO cenik VALUES ('Z363738T','VS2',0,1.3,'EUR');


INSERT INTO objednavka VALUES ('235AT5','96','97');
INSERT INTO objednavka VALUES ('236AT5','96','98','2004-01-01');
INSERT INTO objednavka VALUES ('237AT5','96','98','2004-01-02');

INSERT INTO objednavka_polozky VALUES ('235AT5','R840816',50);
INSERT INTO objednavka_polozky VALUES ('235AT5','R840817',50);

INSERT INTO objednavka_polozky VALUES ('236AT5','B30802T',50);
INSERT INTO objednavka_polozky VALUES ('236AT5','P242118',100);
INSERT INTO objednavka_polozky VALUES ('236AT5','Z363738T',10);

INSERT INTO objednavka_polozky VALUES ('237AT5','P242118',20);
INSERT INTO objednavka_polozky VALUES ('237AT5','Z363738T',20);
